// --------------------------------------------------------------------------------------------
// Gestione dei messaggi a video
// Definizione dell'interfaccia grafica per il debug
//
//
// data: 28-11-99
// data: 18-12-99	Aggiunto pulsante STOP
// data: 24-12-99 Aggiunto pulsante CLEAR
// data: 05-02-2000 Aggiunto opz
// --------------------------------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;

public class Debug extends Frame {

	public TextArea area; 	//area in cui vengono scritti i messaggi
	public TextField mexLine;
	public boolean stop;		//stop=false permette la scrittura su area
	public boolean closed;	//true se l'applicazione ha richiesto la chiusura
	public Panel  opz;      //pannello contenente le righe di pulsanti
	public Panel  puls;     //pannello contenente la prima riga di pulsanti 
	/* Oss: nel caso si voglia estendere la prima riga  necessario, per mantenere
	   la correttezza delle classi fino ad ora create, creare puls come Panel ed 
      inserire qui tutte le modifiche, lasciando cos opz [2,1] */
	
	public Debug( String s ) { 
	  	super ( "DEBUG: " + s );
		stop = false;
		closed = false;
	  	
	  	// impostazione tasto di chiusura della finestra
		addWindowListener	(new WindowAdapter(){
		      public void windowClosing(WindowEvent e){
		      	if (closed) {
			      	dispose();
				      System.exit(0);
				   }
		         else mexLine.setText("Non  possibile chiudere manualmente la finestra!");
			}
		});

		//pulsanti:
		//STOP
		Button stopList = new Button( "STOP" );
		stopList.addActionListener( new StopStart( this, stopList ) );
		//CLEAR
		Button clear = new Button( "CLEAR" );
		clear.addActionListener( new Clear( this ) );
		//pulsantiera per opzioni
		opz = new Panel();
		puls = new Panel();
		puls.setLayout( new GridLayout( 1, 5 ) );
		puls.add( clear );
		puls.add( new Panel() );
		puls.add( new Panel() );
		puls.add( new Panel() );
		puls.add( stopList );
		opz.add( puls );
		//area di testo
		area = new TextArea(); 
		area.setBackground(Color.lightGray);
		area.setEditable( false );
		//area messaggi
		mexLine = new TextField("", 50);
		mexLine.setBackground(Color.white);
		mexLine.setEditable( false );
		
		//impostazioni finestra di Debug	
		setLayout( new BorderLayout() );
		add( opz , BorderLayout.NORTH );	
		add( area, BorderLayout.CENTER );
		add( mexLine, BorderLayout.SOUTH );
		setSize(400,500);
	}// DbgWin
	
	public void outMex( String s ) {
	   if (!stop) area.append( s );
	} //outMex
	
	public void outMexLn( String s ){
	   if (!stop) area.append( s + "\n" );
	} //outMexLn
	
	public void outMexCtr( String s ) {
	   //messaggio su linea di controllo
	   mexLine.setText( s );
	}//outMexCtr
	
	protected class StopStart implements ActionListener {
	
		Debug dg;	//finestra da controllare 
		Button stop;
		public StopStart ( Debug dg, Button stop ) {
			this.dg = dg;
			this.stop = stop;
		}//StopStart
		
		public void actionPerformed( ActionEvent e ) {
			dg.stop = !dg.stop;
			if (dg.stop) {
				stop.setLabel("START");
				mexLine.setText("La visualizzazione  bloccata. Premere START");
			}
			else {
				stop.setLabel("STOP");
				mexLine.setText("Per bloccare i messaggi premere STOP");
			}
		}//actionPerfomed
		
	}//StopStart
 
 	protected class Clear implements ActionListener {
	
		Debug dg;	//finestra da controllare 
		public Clear ( Debug dg ) {
			this.dg = dg;
		}//Clear
		
		public void actionPerformed( ActionEvent e ) {
			area.setText("");
			mexLine.setText("Cancellata l'area messaggi");	
		}//actionPerfomed
		
	}//Clear
	
}//Debug