//-----------------------------------------------------------------------------
// cancLoc.java
// package: FileServer
// 
// comando di cancellazione di un nome logico nel name server globale
//
// data: 23-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;

public class cancLoc extends Comando {

   boolean first = false;
   InetAddress mittente;   //IP di chi propone l'inserimento
   int inPort;             //IP porta di ingresso mittente
   ric r;          //richiesta di inserimento
   gestAnelloNS gs;

   public cancLoc( boolean first, InetAddress mittente, int inPort, ric r ) {
      super( CancDistr );
      this.first = first;
      this.mittente = mittente;
      this.inPort = inPort;
      this.r = r;
   }//cancLoc
   
   public void set( gestore gs ) {
      this.gs = (gestAnelloNS) gs;
   }//set
   
   public void run() {
      synchronized( gs.ns ) {
         try {
            if ( gs.operNS == false ) gs.ns.wait();   
         }
         catch (Exception e) {
            if (DbFS.cancella) DbFS.outMexLn("CMDcancella:(run) Eccezione "+e.toString() );
         }
         metodo();
      }
   }//run
   
   public void metodo() {
      try {
         if (DbFS.cancella) DbFS.outMexLn("CMDcancella: creata nuova istanza");
         ric ricLetta;
         InetAddress thisAdd = InetAddress.getLocalHost();
         if ( mittente.equals( thisAdd ) && inPort == gs.inPort ) {
            //questo  il nodo mittente
            if ( first ) {
               //creazione nuova richiesta
               //controllo presenza locale file da cancellare
               String fis = gs.ns.ricFisico( r.path );
               if ( !fis.equals( nameServer.fisicoEsterno ) && 
                    !fis.equals( nameServer.StringNull )    ) {
                  //file presente
                  //inserisci la richiesta in prop
                  gs.ns.insProp( r );
                  //cancella associazione nel name server locale
                  if (DbFS.cancella) 
                     DbFS.outMexLn("CMDcancella: cancellata associazione locale");
                  gs.ns.cancLogico( r.path );
                  //crea richiesta da propagare
                  ric r2 = new ric( r.path, nameServer.fisicoEsterno, false );
                  if (DbFS.cancella) 
                     DbFS.outMexLn("CMDcancella: inserita proposta r="+r2);
                  //crea thread di trasmissione
                  new gestRit( r2, gs );
                  //propaga la richiesta
                  gs.propaga( new cancLoc( false, mittente, inPort, r2 ), 
                     new elemAgg( r2, mittente, inPort ) ); 
               }
               //else: l'associazione indicata non  presente nel name server locale
            }
            else {
               //richiesta letta dalla rete
               ricLetta = gs.ns.ricProp( r );
               if ( !ricLetta.isNull() ) {
                  //cancellazione della richiesta
                  gs.ns.cancProp( ricLetta );
                  //scarta la richiesta
               }
               //else scarta la richiesta (ritrasmissione in ritardo)
            }
         }
         else {
            //questo non  il nodo mittente
            ricLetta = gs.ns.ricProp( r );
            InetAddress predAct = InetAddress.getByName( "0.0.0.0" );
            if ( gs.inSock.size() > 0 ) 
               predAct = ( (Socket) gs.inSock.elementAt( 0 ) ).getInetAddress();
            if ( predAct.equals( gs.pred ) )
               if ( !ricLetta.isNull() && ricLetta.op == true ) {
                     //in prop c' una richiesta di inserimento
                     //scarta la richiesta
                  }
               else {
                  String fis = gs.ns.ricFisico( r.path );
                  if ( !fis.equals( nameServer.StringNull ) ) {
                     //nome logico presente
                     //cancella nome logico
                     gs.ns.cancLogico( r.path );
                  }
                  //propaga la richiesta
                  gs.propaga( new cancLoc( false, mittente, inPort, r ), 
                     new elemAgg( r, mittente, inPort ) );
               }
            //else scarta la richiesta
         }
      }
      catch ( Exception e ) {
         if (DbFS.cancella) DbFS.outMexLn("CMDcancella:(metodo) Eccezione "+e.toString() );
      }
   }//metodo

}//cancella
