//-----------------------------------------------------------------------------
// clientTest.java
// package: FileServer
// 
// client per il test del server
//
// data: 25-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;

public class clientTest extends Thread{

   InetAddress addS;
   int portS;
   int portC;
   int numServ;
   int nIter;
   int timeout;

   public clientTest( InetAddress addS, int portS, int numServ, int portC, int nIter ) {
      this.addS = addS;
      this.portS = portS;
      this.numServ = numServ;
      this.portC = portC;
      this.nIter = nIter;
      timeout = 10000;
      start();
   }//clientTest
   
   public clientTest( InetAddress addS, int portS, int numServ, int portC, int nIter, 
               int timeout ) {
      this.addS = addS;
      this.portS = portS;
      this.numServ = numServ;
      this.portC = portC;
      this.nIter = nIter;
      this.timeout = timeout;
      start();
   }//clientTest

   public void run() {
      Vector inizio = new Vector( nIter, 0 );
      Vector fine = new Vector( nIter, 0 );
      try {
	      //creazione socket invio datagrammi
	      DatagramSocket sock = new DatagramSocket( portC );
	      sock.setSoTimeout( timeout ); 
         ServerSocket ser = new ServerSocket( portC, 1 );
         ser.setSoTimeout( timeout );
	      String str;
	      DatagramPacket pck;
	      String nomi[] = new String[5];
	      nomi[0] = "prova1"; 
	      nomi[1] = "prova2";
	      nomi[2] = "prova3";
	      nomi[3] = "prova4";
	      nomi[4] = "prova5";
	      String tempo;
         for( int iter=0; iter<nIter; iter++) {
            str = "200 " + nomi[ iter % numServ ];
            pck = new DatagramPacket( str.getBytes(), str.length(), 
                        addS, portS );
            sock.send( pck );
            inizio.addElement( new Long( System.currentTimeMillis() ) );
 	         System.out.println("Spedito comando ("+str+")");
	         try {
	            Socket s = ser.accept();
	            s.close();
	         } catch( Exception exc) {
	            System.out.println("Exc: "+exc);
	         }
            fine.addElement( new Long( System.currentTimeMillis() ) );
         }
         //scrittura su file dei tempi
         FileOutputStream out = new FileOutputStream( String.valueOf( portC )+".txt" );
         while ( inizio.size() > 0 ) {
            String iniLong = ( (Long) inizio.elementAt( 0 ) ).toString()+" ";
            iniLong = iniLong.concat( ((Long) fine.elementAt( 0 )).toString()+"\n");
            out.write( iniLong.getBytes(), 0, iniLong.length() );
            inizio.removeElementAt( 0 );
            fine.removeElementAt( 0 );
         }
         out.close();
      } catch ( Exception e ) {
         System.out.print("(Client "+String.valueOf( portC )+"): Eccezione " +
             e.toString() +"\n");
      }
   }//run
   
   public static void main( String args[] ) {
      //args[0]: IP server a cui inoltrare la richiesta
      //args[1]: porta interprete client su server
      //args[2]: porta client
      //args[3]: numero di iterazioni
      //args[4]: numero di server
      //args[5]: timeout (opzionale)
      try {
         InetAddress addS = InetAddress.getByName( args[0] );
         int portS = Integer.parseInt( args[1] );
         int portC = Integer.parseInt( args[2] );
         int nIter = Integer.parseInt( args[3] );
         int nServ = Integer.parseInt( args[4] );
         if ( args.length == 6 ) {
            int timeout = Integer.parseInt( args[5] );
            new clientTest( addS, portS, nServ, portC, nIter, timeout );
         }
         else 
            new clientTest( addS, portS, nServ, portC, nIter );
      } catch (Exception e) {
         System.out.println("Eccezione: "+e);      
      }
   }//main

}//clientTest
