//-----------------------------------------------------------------------------
// cmd200Class.java
// package: FileServer
// 
// comando di ricerca
//
// data: 19-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class cmd200Class extends Comando {

   trasm       tr;
   nameServer  ns;
   intClient   iC;     //serve per l'invio del codice file non presente
   gestAnello gs;

   InetAddress addC;   //IP cliente
   int         portC;  //porta a cui inviare il file al cliente
   InetAddress addA;   //IP server di affaccio richiesta
   int         inPortA;//porta di ingresso nodo di affaccio
   int         inPort; //porta di ingresso di questo nodo (rete server)
   boolean     affaccio; //true se il comando esegue per la prima volta
   pathName    path;   //path da ricercare
   
   public cmd200Class( InetAddress addC, int portC, InetAddress addA, int inPortA,
                  boolean affaccio, pathName path ) {
      super( Ricerca );
      this.addC = addC;
      this.portC = portC;
      this.addA = addA;
      this.inPortA = inPortA;
      this.affaccio = affaccio;
      this.path = path;      
   }//cmd200Class

   public void set( gestore gs ) {
      this.tr = gs.tr;   //aggancio trasmettitore
      this.ns = gs.ns;   //aggancio nameServer
      this.iC = gs.iC;   //aggancio interprete cliente
      this.gs = ( gestAnello ) gs;
      this.inPort = ( (gestAnelloNS) gs ).inPort;
      if (DbFS.cmd200Class) 
         DbFS.outMexLn(getName()+": cmd200Class set( gestore gs ) ");
   }//set
   
   public String toString() {
      return "cmd200Class: (C/"+addC.toString()+":"+String.valueOf(portC)+") path = "+
             path.toString()+ " affaccio=" + String.valueOf( affaccio ) +
             " addA="+addA.toString() ;
   }//toString
   
   public void run() {
      try {
         if ( DbFS.cmd200Class )
             DbFS.outMexLn(getName()+": (ricerca) metodo run()");
         if ( affaccio && DbFS.cmd200Class ) 
            DbFS.outMexLn(getName()+": (ricerca) comando su nodo affaccio\n"+
            getName()+":(ricerca) addA = "+ addA.toString() );
         InetAddress predAct = ( ((Socket) gs.inSock.elementAt( 0 )).getInetAddress() );
         if (    !affaccio && 
               ( ( addA.equals( InetAddress.getLocalHost() ) && inPort == inPortA ) ||
                 ( addA.equals( gs.pred ) && !predAct.equals( gs.pred ) ) )
            ) {
            //la richiesta ha compiuto un giro completo dell'anello
            if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": la ricerca di " +
               path.toString()+" non ha avuto successo");
            //creazione datagramma per risposta negativa
            DatagramPacket pck = new DatagramPacket( FileNonPresente.getBytes(), 
               FileNonPresente.length(), addC, portC ); 
            iC.sock.send( pck );
         }
         else {
            //ricerca nel name Server locale
            String file = ns.ricFisico( path );
            if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": fisico="+file+"*" );
            if ( file.equals( nameServer.StringNull ) ) {
               //nome logico non presente nel name server
            DatagramPacket pck = new DatagramPacket( FileNonPresente.getBytes(), 
               FileNonPresente.length(), addC, portC ); 
            iC.sock.send( pck );
            }
            else { 
               if ( file.equals( nameServer.fisicoEsterno) ) {
                  //nome logico non locale a questo nodo
                  //propagazione della richiesta
                  if (DbFS.cmd200Class) 
                     DbFS.outMexLn(getName()+": propagazione della ricerca"+
                     " di "+path.toString() );
                  tr.invia( new cmd200Class( addC, portC, addA, inPortA, false, path ) );
               }
               else {
                  //nome logico presente nel nodo
                  if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": " +
                     path.toString()+" trovato. Comincia la trasmissione al cliente");
                  FileInputStream fIn=null;
                  Socket s=null;
                  BufferedOutputStream sOut=null;
                  try {
                     //apertura file
                     fIn = new FileInputStream( file );
                     //creazione della socket per l'invio del file
                     s = new Socket( addC, portC );
                     sOut = new BufferedOutputStream( s.getOutputStream() );
                     int len = 4096; 
                     byte c[] = new byte[ len ];
                     //invio nome logico file
                     String logFile = path.toString();
                     int lung = logFile.length();
                     for ( int i=lung; i< pathName.maxPath; i++ ) 
                         logFile = logFile.concat( new String(" ") );
                     byte d[] = logFile.getBytes();
                     sOut.write( d, 0, pathName.maxPath );
                     if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": trasmesso "+
                     " nome logico("+ logFile + ")");
                     int r = 0;
                     while ( r!=-1 ) {
                        //lettura da file
                        r = fIn.read( c, 0, len );
                        if ( r>0 )
                           //scrittura su socket
                           sOut.write( c, 0, r );
                     }
                     if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": finita la " +
                        "trasmissione di "+path.toString());
                  } catch ( Exception e ) {
                     //se succede qualcosa si rinuncia alla trasmissione
                        if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": trasmissione di "+
                           path.toString()+" interrotta (eccezione:"+e+")");
                  } finally {
                     try {
                        fIn.close();
                        sOut.flush();
                        sOut.close();
                     } catch ( Exception g ) {
                        if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": Eccezione " +
                           g.toString() );
                     }
                  }
               }
            }
         }
      } catch ( Exception f ) {
         if (DbFS.cmd200Class) DbFS.outMexLn(getName()+": Eccezione "+f.toString() );
      }
   }//run
   
}//cmd200Class
