//-----------------------------------------------------------------------------
// cmd500Class.java
// package: FileServer
// 
// comando di inserimento nuovo server
//
// data: 27-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class cmd500Class extends Comando {

   gestReteAnello gs;

   boolean first;
   int passi;   //migliore offerta
   InetAddress addNS;      //IP nuovo server 
   int portNS;
   InetAddress mittente;   //nodo affaccio richiesta
   int inPort;             //porta di ingresso mittente
   InetAddress predBest;   //IP miglior nodo predecessore
   int portServP;
   InetAddress pred2Best;  //IP predecessore miglior nodo predecessore
   int portServP2;
   
   public cmd500Class( InetAddress addNS, int portNS ) {
      super( newServer );
      this.addNS = addNS;
      this.portNS = portNS;
   }//cmd500Class
   
   public cmd500Class( InetAddress addNS, int portNS, InetAddress mittente, int inPort,
            InetAddress predBest, int portServP, InetAddress pred2Best, 
            int portServP2, int passi ) {
      super( newServer );
      this.addNS = addNS;
      this.portNS = portNS;
      this.mittente = mittente;
      this.inPort = inPort;
      this.predBest = predBest;
      this.portServP = portServP;
      this.pred2Best = pred2Best;
      this.portServP2 = portServP2;
      this.passi = passi;
   }//cmd500Class
   
   public void set( gestore gs ) {
      this.gs = ( gestReteAnello ) gs;
   }//set
   
   public void crea() {
      //creazione del comando
      try {
         passi = ricCache( addNS );
         //invio del nuovo comando sulla rete
         gs.tr.invia( new cmd500Class( addNS, portNS, InetAddress.getLocalHost(), gs.inPort,
           InetAddress.getLocalHost(), gs.portServer, gs.pred, gs.portServPred, passi ) );
      }
      catch ( Exception e ) {
         if (DbFS.cmd500Class) DbFS.outMexLn("cmd500Class:(crea) Eccezione "+e.toString() );
      }
   }//crea

   public void run() {
      try {
         //predecessore attuale
         InetAddress predAct = ( ((Socket) gs.inSock.elementAt( 0 )).getInetAddress() );
         if ( ( InetAddress.getLocalHost().equals( mittente ) && inPort == gs.inPort )|| 
              ( gs.pred.equals( mittente ) && !gs.pred.equals( predAct ) )
            ) {
            //la richiesta ha compiuto un giro dell'anello
            if (DbFS.cmd500Class) {
               DbFS.outMexLn("cmd500Class: la richiesta ha compiuto un giro");
               DbFS.outMexLn("cmd500Class: porta server nodo corrente"
                  +String.valueOf( gs.portServer) );
               DbFS.outMexLn("cmd500Class: tento di collegarmi col miglior predecessore" +
                  " IP="+predBest+";port="+String.valueOf(portServP) );
            }
            if ( predBest.equals( InetAddress.getLocalHost() ) 
                  && portServP == gs.portServer ){ //condizione per test in locale
               //questo nodo e' il predecessore migliore
               if (DbFS.cmd500Class) 
                  DbFS.outMexLn("cmd500Class: questo nodo  il miglior predecessore"); 
               predScelto pS = new predScelto( addNS, portNS );
               pS.set( gs );
               pS.start();
            }
            else { //comunico con il predecessore migliore
               Socket sPred = gs.ripSucc( predBest, portServP, /*gs.portServer*/ -1 );
               if (DbFS.cmd500Class) 
                  DbFS.outMexLn("cmd500Class: tento di collegarmi col pred" +
                  " IP="+predBest+";port="+String.valueOf(portServP) );
               if (  sPred == null ) {
                  if (DbFS.cmd500Class) 
                     DbFS.outMexLn("cmd500Class: collegamento con predBest non riuscito");
                  //collegamento con predecessore migliore non riuscito
                  //per hp: pred del pred presente
                  if (DbFS.cmd500Class) 
                     DbFS.outMexLn("cmd500Class: tento di collegarmi col pred2" +
                     " IP="+pred2Best+";port="+String.valueOf(portServP2) );
                  if ( pred2Best.equals( InetAddress.getLocalHost() ) 
                        && portServP2 == gs.portServer ) { //test in locale
                     //questo nodo e' il predecessore 2 migliore
                  if (DbFS.cmd500Class) 
                     DbFS.outMexLn("cmd500Class: questo nodo  il miglior pred2"); 
                     predScelto pS = new predScelto( addNS, portNS );
                     pS.set( gs );
                     pS.start();
                  }
                  else { //comunico con il predecessore 2 migliore
                     sPred = gs.ripSucc( pred2Best, portServP2, -1 );
                     if (DbFS.cmd500Class) 
                       DbFS.outMexLn("cmd500Class: collegamento con pred2 riuscito"); 
                  }
               }
               else 
                  if (DbFS.cmd500Class) 
                     DbFS.outMexLn("cmd500Class: collegamento con predBest riuscito");
               //invia comando: scelto predecessore
               ObjectOutputStream outObj = new ObjectOutputStream( sPred.getOutputStream() );
               outObj.writeObject( new predScelto( addNS, portNS ) );
               if (DbFS.cmd500Class) 
                  DbFS.outMexLn("cmd500Class: inviato comando di predScelto (IP="+addNS+
                  "; port="+String.valueOf( portNS ) );
               sPred.close();
            }
         }
         else {
            // passiAct = calcola passi da questo nodo
            InetAddress locAdd = InetAddress.getLocalHost();
            int passiAct = ricCache( addNS );
            if ( passiAct < passi ) {
               // questo nodo e' il migliore 
               if (DbFS.cmd500Class) 
                  DbFS.outMexLn("cmd500Class: questo  il nodo migliore (passiAct="+
                  String.valueOf( passiAct )+"; passi= "+String.valueOf( passi )+")" );
               gs.tr.invia( new cmd500Class( addNS, portNS, mittente, inPort,
                     locAdd, gs.portServer, gs.pred, 
                     gs.portServPred, passiAct ) );
            }
            else
               //questo nodo non e' migliore dei precedenti
               if (DbFS.cmd500Class) 
                  DbFS.outMexLn("cmd500Class: questo non  il nodo migliore (passiAct="+
                  String.valueOf( passiAct )+"; passi= "+String.valueOf( passi )+")" );
               gs.tr.invia( new cmd500Class( addNS, portNS, mittente, inPort, predBest, 
                        portServP, pred2Best, portServP2, passi ) ); 
         }
      } catch ( Exception e ) {
         if (DbFS.cmd500Class) DbFS.outMexLn("cmd500Class:(run) Eccezione "+e.toString() );
      }
   }//run
   
   public int ricCache( InetAddress addNS ) throws Exception {
       synchronized( gs.richieste ) {
          //ricerca in tabella 
          int passiAct = 0;
          int index = gs.richieste.indexOf( addNS );
          if ( index < 0 ) {
             if (DbFS.cmd500Class) DbFS.outMexLn("cmd500Class:(ricCache)richiesta "+
                "non presente in tabella");
             //richiesta non presente in tabella
             //passi = calcola passi da questo nodo
             passiAct = gs.contaPassi( InetAddress.getLocalHost() );
             if ( gs.richieste.size() == gestReteAnello.maxElem ) {
                //togli primo elemento inserito
                gs.richieste.removeElementAt( 0 );
                gs.passi.removeElementAt( 0 );
             }
             //inserisci nuovo indirizzo
             gs.richieste.addElement( addNS );
             gs.passi.addElement( new Integer( passi ) );
          }
          else { //richiesta gi presente
             passiAct = ( (Integer) gs.passi.elementAt( index ) ).intValue();
             if (DbFS.cmd500Class) DbFS.outMexLn("cmd500Class:(ricCache)richiesta "+
                "presente in tabella");
          }
          return passiAct;
       }
   }//ricCache

}//cmd500Class