//-----------------------------------------------------------------------------
// confGestAnello.java
// package: FileServer
// 
// crea un file per la configurazione di una rete con topologia ad anello
//
// data: 03-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;

public class confGestAnello {

   public static void main( String args[] ) {
      //args[0]: nome file da creare
      //args[1]: IP successore
      //args[2]: porta di ingresso del successore
      //args[3]: IP succ2
      //args[4]: porta di ingresso del succ2
      //args[5]: IP predecessore
      //args[6]: inPort locale al server (opzionale: default)
      //args[7]: outPOrt locale al server (opzionale: default)
      //args[8]: portClient (opzionale: default)
      System.out.println("Lista dei parametri passati");
      int i = 0;
      while ( i < args.length ) {
         System.out.println("args[" + i + "]: " + args[i] );
         i++;
      }
      if ( args.length!= 6 && args.length!= 9 ) {
         System.out.println("Errore: numero sbagliato di parametri");
         System.exit(1);
      }
      try {
      //controllo della correttezza degli argomenti
      InetAddress ipSucc = InetAddress.getByName( args[1] );
      Integer portSucc = new Integer( args[2] );
      InetAddress ipSucc2 = InetAddress.getByName( args[3] );
      Integer portSucc2 = new Integer( args[4] );
      InetAddress ipPred = InetAddress.getByName( args[5] );
      Integer inPort;
      Integer outPort, portClient, portServer;
      if ( args.length == 9 ) { 
         inPort = new Integer( args[6] );
         outPort = new Integer( args[7] );
         portClient = new Integer( args[8] );
      }
      else {
         inPort = new Integer( FileServer.gestAnello.inPortDefault );
         outPort = new Integer( FileServer.gestAnello.outPortDefault );
         portClient = new Integer( FileServer.gestAnello.portClientDefault );
      }
      System.out.println("Argomenti corretti, apro il file ");
      FileOutputStream f = new FileOutputStream( args[0] );
      ObjectOutputStream outObj = new ObjectOutputStream( f );
      outObj.writeObject( inPort );
      outObj.writeObject( outPort );
      outObj.writeObject( ipSucc );
      outObj.writeObject( portSucc );
      outObj.writeObject( ipSucc2 );
      outObj.writeObject( portSucc2 );
      outObj.writeObject( ipPred );
      outObj.writeObject( portClient );
      System.out.println("Finito main");
      } catch (Exception e) {
         System.out.println("Eccezione: "+e.toString() );
      }
   }//main

}//confGestAnello