//-----------------------------------------------------------------------------
// gestAnelloNS.java
// package: FileServer
// 
// gestore del name Server per una rete con una topologia ad anello
//
// data: 23-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.util.*;

public class gestAnelloNS extends gestAnello {

	public static long timeOut = 10000;    //timeOut per ritrasmissioni in ms
	
	public boolean operNS;      //true = il name server  aggiornato

	protected Vector ricTab = new Vector( dimRicTab, incRicTab );   
	//tabella in cui vengono inserite le operazioni sul name server perse 
	//dal successore caduto
	protected static int dimRicTab = 10;
	protected static int incRicTab = 5;

   public gestAnelloNS( String fileNameServer ) throws Exception {
      super( fileNameServer );
      aggiornaOut();
      avviaRit();
   }//gestAnelloNS
   
   public gestAnelloNS( String fileNameServer, int inPort, int outPort, int portClient )
      throws Exception {
      super( fileNameServer, inPort, outPort, portClient );
      aggiornaOut();
      avviaRit();
   }//gestAnelloNS

   public gestAnelloNS( String fileNameServer, int inPort, int outPort ) 
      throws Exception {
      this( fileNameServer, inPort, outPort, portClientDefault );
   }//gestAnelloNS
   
   public gestAnelloNS( String fileNameServer, String fileConfig ) 
      throws Exception {
      super( fileNameServer, fileConfig );
      aggiornaOut();
      avviaRit();
   }//gestAnelloNS
   
   public void propaga( Comando cmd, elemAgg e ) {
   //propagazione del comando con attenzione all'eventuale memorizzazione
   //per il successore caduto
      if ( operNS ) {
         //il nodo  gi operativo
         if ( !disp ) {
            if (DbFS.gestAnelloNS) DbFS.outMexLn("propaga: successore caduto, scritto "+
            e.toString()+" su tabella aggiornamento");
            ricTab.addElement( e );
         }
         if (DbFS.gestAnelloNS) DbFS.outMexLn("propaga: propagato e="+e.toString());        
         tr.invia( cmd );
     }
      else 
         if(DbFS.gestAnelloNS)
            DbFS.outMexLn("propaga: fase di aggiornamento, non bisogna propagare nulla");
   }//propaga
   
   public synchronized void aggiornaOut() {
      if (DbFS.gestAnelloNS) DbFS.outMexLn("(gestAnelloNS) tabella aggiornamento "+
         ricTab.toString() );
      //invio comando di aggiornamento name Server
      if (DbFS.gestAnelloNS) DbFS.outMexLn("(gestAnelloNS) aggiornaOut");
      tr.invia( new aggiorna( ricTab ) );
      if (DbFS.gestAnelloNS) DbFS.outMexLn("(gestAnelloNS) propagata tabella aggiornamento");
   }//aggiornaOut
   
   public synchronized void avviaRit(){
      for (int i = 0; i < ns.prop.size(); i++) {
         ric r = (ric) ns.prop.elementAt( i );
         //generazione thread ritrasmissioni
         new gestRit( r, this );
         if (DbFS.nameServer) 
            DbFS.outMexLn("(nameServer): generato thread ritrasmissione "+
            "proposta r="+r );
      }
   }//avviaRit

}//gestAnelloNS