//-----------------------------------------------------------------------------
// gestAnelloPatch.java
// package: FileServer
// 
// gestore per una rete con una topologia ad anello; patch per problema 
// rilevazione caduta socket
//
// data: 26-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.util.*;

public class gestAnelloPatch extends gestAnello {

   public gestAnelloPatch( ) throws Exception {
      super();
   }//gestAnelloPatch

   public gestAnelloPatch( String fileNameServer ) throws Exception {
      super( fileNameServer );
   }//gestAnelloPatch

   public gestAnelloPatch( String fileNameServer, String fileConfig ) throws Exception {
      super( fileNameServer, fileConfig );
   }//gestAnelloPatch
   
   public gestAnelloPatch( int inPort, int outPort ) throws Exception {
      super( inPort, outPort );
   }//gestAnelloPatch
   
   public gestAnelloPatch( String fileNameServer, int inPort, int outPort ) 
            throws Exception {
      super( fileNameServer, inPort, outPort );
   }//gestAnelloPatch

   protected void init() {
      //impostazione della tabella dei buffer di uscita (crea nuova istanza di trasm)
      tr = new trasmPatch( this, 1, 0 );
      //impostazione della tabella dei buffer di ingresso ( "        "   di intServer)
      is = new intServer( this, ns, tr, 1, 0 );
      //creazione delle 2 tabelle per le socket di ingresso ed uscita
      inSock = new Vector( 1, 1 );
      outSock = new Vector( 1, 0 );
   }//init
   
   public synchronized void newOutSocket( Socket sOut ) {
      //richiesta di inserimento di una nuova socket di uscita
      //inserimento della socket nella tabella delle socket di uscita
      if (DbFS.gestAnelloPatch) DbFS.outMexLn("(gestAnelloPatch) (newOutSocket): ingresso" );
      //inserimento nuova entry nella tabella delle socket di uscita
      outSock.addElement( sOut );
      try {
         //inserimento nella tabella di trasmissione
         OutputStream oStr = sOut.getOutputStream();
         ObjectOutputStream oStrObj = new ObjectOutputStream( oStr );
         tr.ins( oStrObj );
      if (DbFS.gestAnelloPatch) 
         DbFS.outMexLn("(gestAnelloPatch) (newOutSocket): creato thread ascolto connessione" );
         //creazione del thread di ascolto della connessione
         socketPatch sP = new socketPatch( sOut, this );
         ( ( trasmPatch) tr).insPatch( sP );
      } catch ( IOException e ) {
         //operazione fallita, cancello quanto gi fatto
         outSock.removeElement( sOut );
         if (DbFS.gestAnello) 
            DbFS.outMexLn("(gestAnello): (newOutSocket) Eccezione "+ e.toString() );
      }
   }//newOutSocket
   
   public synchronized void notifyCrashOut( int ind, Comando cmd ) {
      if (DbFS.gestAnello) 
         DbFS.outMexLn("(gestAnello) (notCrashOut): caduto ind " + String.valueOf( ind ));
      if (first) {
         first = false;
         if ( disp ) {
            //caduta del successore
            disp = false;
            //avvia thread per la gestione della caduta del successore
            if (DbFS.gestAnello) 
               DbFS.outMexLn("(gestAnello) (notCrashOut): caduto successore");
            new crashSucc( this );
         }
         else {
            if (DbFS.gestAnello) 
               DbFS.outMexLn("(gestAnello) (notCrashOut): successore tornato");
            //il successore  tornato
            //avvia thread per la gestione del ritorno
            new ritSucc( this );
         }
      }
      if ( cmd != null ) {
         coda.addElement( cmd ); //inserisci messaggio in coda
         if (DbFS.gestAnello) 
            DbFS.outMexLn("(gestAnello) (notifyCrashOut): inserito in coda " 
            + cmd.toString() );
      }
   }//notifyCrashOut
   
}//gestAnelloPatch
