//-----------------------------------------------------------------------------
// initInSock.java
// package: FileServer
// 
// thread per l'accettazione delle socket di "ingresso" in una rete con
// topologia ad anello
//
// data: 22-01-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;

public class initInSock extends Thread {

   protected gestAnello gs;

   public initInSock( gestAnello gs ) {
   super();
   if (DbFS.initInSock)
         DbFS.outMexLn("(initInSock): entrato in costruttore");
      this.gs = gs;
      start();      
   }//initInSock

   private ServerSocket initSer() {
      try {
         return new ServerSocket( gs.inPort );
      } catch( IOException e ) {
         if (DbFS.initInSock) 
            DbFS.outMexLn("(initInSock): IOException (new ServerSocket)");
         return initSer();
      }
   }//init
   
   public void run() {
      ServerSocket ser = initSer();
      Socket soc;
      while( true ) {
         if (DbFS.initInSock) DbFS.outMexLn("(initInSock): attesa di nuova" +
            " connessione alla porta " + ser.getLocalPort() );
         try {
            soc = ser.accept();
            if (DbFS.initInSock) 
               DbFS.outMexLn("(initInSock): accettata nuova connessione (" + 
               soc.toString() + ")" );
            //controllo che la nuova connessione sia con il predecessore
            if ( soc.getInetAddress().equals( gs.pred ) ) {
               //la nuova connessione  instaurata con il predecessore 
               if (DbFS.initInSock)
                  DbFS.outMexLn("(initInSock): connessione con il predecessore");
               if ( gs.inSock.size() == 1 ) {
                  if (DbFS.initInSock) 
                     DbFS.outMexLn("(initInSock): dopo la sua caduta");
                  //c' la connessione con il predecessore del predecessore da eliminare
                  //chiudo la socket di ingresso (thrIn sentir la chiusura)
                  if ( gs.inSock.size() > 0 )
                     ( (Socket) gs.inSock.elementAt( 0 ) ).close();
                  if (DbFS.initInSock)
                     DbFS.outMexLn("(initInSock): chiusa socket con pred2");
               }
            }
            //attesa di aggiornamento
            gs.aggiornaIn();
            //inserimento della nuova socket
            gs.newInSocket( soc );
         } catch ( IOException e ) {
            if (DbFS.initInSock) DbFS.outMexLn("(initInSock): IOException" +
               " (ser.accept)");
         }
      }
   }//run
   
   public static void main( String args[] ) {
      //per testare il modulo  necessario avere un client che richieda una 
      //connessione (provaFS/c4.jpr)
      DbFS.OpenDbgWin("initInSock");
      DbFS.CloseDbgWin();
   }//main

}//initInSock