//-----------------------------------------------------------------------------
// insLoc.java
// package: FileServer
// 
// comando di inserimento di un nuovo nome logico nel name server globale
//
// data: 22-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;

public class insLoc extends Comando {

   boolean first = false;
   InetAddress mittente;   //IP di chi propone l'inserimento
   int inPort;             //inPort mittente
   ric r;          //richiesta di inserimento
   gestAnelloNS gs;
   
   public insLoc( boolean first, InetAddress mittente, int inPort, ric r ) {
      super( InsDistr );
      if (DbFS.inserisci) DbFS.outMexLn("CMDinsLoc: creata nuova istanza");
      this.first = first;
      this.mittente = mittente;
      this.inPort = inPort;
      this.r = r;
   }//inserisci
   
   public void set( gestore gs ){
      this.gs = (gestAnelloNS) gs;
   }//set
   
   public void run() {
     if (DbFS.inserisci) DbFS.outMexLn("CMDinsLoc: metodo run");
     synchronized( gs.ns ) {
         try {
            if ( gs.operNS == false ) {
               if (DbFS.inserisci) DbFS.outMexLn("CMDinsLoc: server non ancora "+
                  "operativo. Thread messo in attesa.");
               gs.ns.wait();   
            }
         }
         catch (Exception e) {
            if (DbFS.inserisci) 
               DbFS.outMexLn("CMDinsLoc: (run)Eccezione "+e.toString() );                   
         }
         metodo( );
      }
   }//run
   
   public void metodo( ) {
     if (DbFS.inserisci) 
        DbFS.outMexLn("CMDinsLoc: (r="+ r.toString()+"; mittente="+mittente.toString()+
        "; inPort="+String.valueOf( inPort ) );
     //viene introdotto per eseguire le operazioni di aggiornamento
     try {
      ric ricLetta, ricEst;
      InetAddress thisAdd = InetAddress.getLocalHost();
      if ( mittente.equals( thisAdd ) && gs.inPort == inPort ) {
         if (DbFS.inserisci) DbFS.outMexLn("CMDinsLoc: la richiesta  nel nodo mittente");
         if (first) {
            String fis = gs.ns.ricFisico( r.path );
            //controllo non vi sia gi l'associazione
            if ( fis.equals( nameServer.StringNull ) ) {
               if (DbFS.inserisci) 
                  DbFS.outMexLn("CMDinsLoc: creazione nuovo comando");
               //inserimento della richiesta in prop
               gs.ns.insProp( r );
               if (DbFS.inserisci) 
                  DbFS.outMexLn("CMDinsLoc: inserito r="+r);
               //creazione richiesta da propagare
               ricEst = new ric( r.path, nameServer.fisicoEsterno, r.op );
               if (DbFS.inserisci) 
                  DbFS.outMexLn("CMDinsLoc: si propaga r="+ricEst );
               //creazione del thread di gestione delle ritrasmissioni
               new gestRit( ricEst, gs );               
               //propagazione della richiesta
               if (DbFS.inserisci) 
                  DbFS.outMexLn("CMDinsLoc: propagazione nuovo comando");
               gs.propaga( new insLoc( false, mittente, inPort, ricEst), 
                  new elemAgg( ricEst, mittente, inPort )  );
            }
         }
         else { //richiesta letta dalla rete
            ricLetta = gs.ns.ricProp( r );
            if ( !ricLetta.isNull() ) {
               //la richiesta ha fatto un giro intero dell'anello
               if (DbFS.inserisci) 
                  DbFS.outMexLn("CMDinsLoc: la richiesta ha fatto un giro completo");               
               ricLetta = gs.ns.ricProp( r );
               //inserimento nel name Server locale della nuova corrispondenza
               gs.ns.inserisci( ricLetta.fis, ricLetta.path );
               //cancellazione della richiesta dalla tabella delle proposte
               gs.ns.cancProp( r );
               //scarta la richiesta
            }
            //else ritrasmissione arrivata in ritardo: scarta la richiesta
         }
      }
      else { //questo non  il nodo mittente della richiesta
         if (DbFS.inserisci) 
            DbFS.outMexLn("CMDinsLoc: ricevuta richiesta r="+r+
            "\nCMDinsLoc: questo non  il nodo mittente");
         ricLetta = gs.ns.ricProp( r );
         if (DbFS.inserisci) 
            DbFS.outMexLn("CMDinsLoc: ricLetta="+ricLetta);
         InetAddress predAct = InetAddress.getByName( "0.0.0.0" );
         if ( gs.inSock.size() > 0 ) 
            predAct = ( (Socket) gs.inSock.elementAt( 0 ) ).getInetAddress();
         if ( predAct.equals( gs.pred ) )
            //controllo della presenza in prop della richiesta
            if ( ricLetta.isNull() ) {
               //richiesta non presente
               if (DbFS.inserisci) 
                 DbFS.outMexLn("CMDinsLoc: richiesta non presente");
               String fis = gs.ns.ricFisico( r.path );
               if ( fis.equals( nameServer.StringNull ) ) {
                  //nome logico non presente nel name server 
                  //inserisci nuova corrispondenza nel name Server locale
                  if (DbFS.inserisci) 
                     DbFS.outMexLn("CMDinsLoc: inserita nuova associazione "+
                     "(r=" + r.toString()+") in NS locale");
                  gs.ns.inserisci( r.fis, r.path );
                  //propaga la richiesta
                  gs.propaga( new insLoc( false, mittente, inPort, r), 
                     new elemAgg( r, mittente, inPort ) );
               }
               else { //nome logico gi presente
                  if ( fis.equals( nameServer.fisicoEsterno ) ) {
                     //propagazione della richiesta
                     gs.propaga( new insLoc( false, mittente, inPort, r), 
                        new elemAgg( r, mittente, inPort ) );
                  }
                  else {
                     if (DbFS.inserisci) 
                        DbFS.outMexLn("CMDinsLoc: 2 inserimenti uguali");                   
                     //corrispondenza presente
                     long fx = gs.ns.f( thisAdd, gs.inPort, r.path );
                     long fy = gs.ns.f( mittente, inPort, r.path );
                     if (DbFS.inserisci) 
                        DbFS.outMexLn("CMDinsLoc: fX="+String.valueOf(fx) +
                        " fY="+String.valueOf(fy));                   
                     if ( fx > fy ) {
                        //cancella la corrispondenza presente
                        gs.ns.cancLogico( r.path );
                        //inserisci la corrispondenza nel name Server locale
                        gs.ns.inserisci( r.fis, r.path );
                        //propagazione della richiesta
                        gs.propaga( new insLoc( false, mittente, inPort, r ), 
                           new elemAgg( r, mittente, inPort ) );
                     }
                     //else scarta la richiesta   
                  }
               }
            }
            else { //richiesta presente in prop
               if (DbFS.inserisci) 
                 DbFS.outMexLn("CMDinsLoc: richiesta presente");
               if ( ricLetta.op ) {
                  // una richiesta di inserimento
                  long fx = gs.ns.f( thisAdd, gs.inPort, r.path );
                  long fy = gs.ns.f( mittente, inPort, r.path );
                  if ( fx > fy ) {
                     //cancella la richiesta da prop
                     gs.ns.cancProp( ricLetta );
                     //inserisci la corrispondenza nel name Server locale
                     gs.ns.inserisci( r.fis, r.path );
                     //propagazione della richiesta
                     gs.propaga( new insLoc( false, mittente, inPort, r ), 
                        new elemAgg( r, mittente, inPort ) );
                  }
                  //else scarta la richiesta   
               }
               else {
                  // una richiesta di cancellazione
                  if (DbFS.inserisci) 
                     DbFS.outMexLn("CMDinsLoc: presente richiesta di "+
                     "cancellazione");                   
                  //cancella da prop la richiesta
                  gs.ns.cancProp( ricLetta );
                  //inserisci la nuova corrispondenza nel name Server locale
                  gs.ns.inserisci( r.fis, r.path );
                  //propaga la richiesta
                  gs.propaga( new insLoc( false, mittente, inPort, r ),
                     new elemAgg( r, mittente, inPort ) );
               }
            }
         //else scarta la richiesta
      }
     } catch ( Exception e ) {
        if (DbFS.inserisci) 
           DbFS.outMexLn("CMDinsLoc: Eccezione "+e.toString() );
     }
     finally {
        if (DbFS.inserisci) DbFS.outMexLn("CMDinsLoc: lista\n"+ gs.ns.lista());
     }
   }//metodo

}//insLoc