//-----------------------------------------------------------------------------
// intClient.java
// package: FileServer
// 
// interprete dei comandi client
//
// data: 18-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;
import io.*;         //serve nel main per l'uso della finestra di input

public class intClient extends intDat {
// Tabella dei comandi
// Comando         Metodo
// ----------------------
// 200             cmd200   ricerca
// 300             cmd300   lista
// 000             cmd000   gestione comando inesistente  
  
   gestAnelloNS gs;
   
   public intClient( gestore gs ) throws SocketException {
      super( gs );
      this.gs = ( gestAnelloNS ) gs;
      //creazione della socket
      sock = new DatagramSocket( ( (gestAnello) gs).portClient );
      dati = new byte[ lungDati ];
      com = new Vector( 2, 1 );
      met = new Vector( 2, 1 );
      Class prm[] = new Class[ 2 ];
      try { 
         prm[0] = Class.forName( "java.io.StreamTokenizer" ); 
         prm[1] = Class.forName( "java.net.DatagramPacket" ); 
         Class thisClass = Class.forName( "FileServer.intClient" );
         //creazione tabella dei comandi
         com.addElement( new Integer( 200 ) );   //comando di ricerca
         met.addElement( thisClass.getDeclaredMethod( "cmd200", prm ) );
         com.addElement( new Integer( 300 ) );   //comando di lista
         met.addElement( thisClass.getDeclaredMethod( "cmd300", prm ) );
         com.addElement( new Integer( 0 ) ) ;    //comando inesistente
         prm = new Class[ 1 ];
         prm[0] = Class.forName( "java.net.DatagramPacket" );
         met.addElement( thisClass.getDeclaredMethod( "cmd000", prm ) );
         start();
      }
      catch ( Exception e ) {
         if (DbFS.intClient) DbFS.outMexLn(getName()+": Eccezione "+e.toString() );
      }
   }//intClient
   
   void cmd200( StreamTokenizer str, DatagramPacket pck ) {
      DatagramPacket pckInvio;
      InetAddress addC = pck.getAddress();
      int portC = pck.getPort();
      if (DbFS.intClient) DbFS.outMexLn(getName()+": analisi comando di ricerca");
      try {
         str.nextToken();
         if ( str.ttype != StreamTokenizer.TT_WORD ) {
            //sintassi scorretta
            if (DbFS.intClient) DbFS.outMexLn(getName()+"(ricerca): sintassi scorretta");
            pckInvio = new DatagramPacket( Comando.SintassiScorretta.getBytes(), 
               Comando.FileNonPresente.length(), addC, portC ); 
            sock.send( pckInvio );
         }
         else {
            String r = str.sval;
            str.nextToken();
            if (str.ttype != StreamTokenizer.TT_EOF ) {
               //sintassi scorretta
               if (DbFS.intClient) 
                  DbFS.outMexLn(getName()+"(ricerca): sintassi scorretta");
               pckInvio = new DatagramPacket( Comando.SintassiScorretta.getBytes(), 
                  Comando.SintassiScorretta.length(), addC, portC ); 
               sock.send( pckInvio );
            }
            else {
               //controllo path corretto
               try {
                  pathName path = new pathName( r );
                  if (DbFS.intClient) 
                     DbFS.outMexLn(getName()+"(ricerca): path " + path.toString() );
                  //creazione nuovo comando
                  if (DbFS.intClient) 
                     DbFS.outMexLn(getName()+"(ricerca): creazione nuova istanza comando");
                  cmd200Class c = new cmd200Class( addC, portC,
                     InetAddress.getLocalHost(), gs.inPort, true, path );
                  c.set( gs );
                  c.start();
               } catch( NotWellFormedException d ) {
                  //path non corretto
                  if (DbFS.intClient) 
                     DbFS.outMexLn(getName()+"(ricerca): path non corretto");
                  pckInvio = new DatagramPacket( Comando.PathScorretto.getBytes(), 
                     Comando.PathScorretto.length(), addC, portC ); 
                  sock.send( pckInvio );
               }
            }
         }
      } catch ( Exception e ) {
         if (DbFS.intClient) 
            DbFS.outMexLn(getName()+"(ricerca): Eccezione "+e.toString());
      }
   }//cmd200
   
   void cmd300( StreamTokenizer str, DatagramPacket pck ) {
      InetAddress addC = pck.getAddress();   //IP client
      int portC = pck.getPort();             //porta client
      if (DbFS.intClient) DbFS.outMexLn(getName()+": analisi comando di lista");
      try {
         str.nextToken();
         if ( str.ttype != StreamTokenizer.TT_EOF ) {
            //sintassi scorretta
            if (DbFS.intClient) 
               DbFS.outMexLn(getName()+"(lista): Sintassi scorretta" );
            DatagramPacket pckInvio = new DatagramPacket( Comando.SintassiScorretta.getBytes(), 
               Comando.FileNonPresente.length(), addC, portC ); 
            sock.send( pckInvio );
         }
         else {
            //creazione nuovo comando
            if (DbFS.intClient) 
               DbFS.outMexLn(getName()+"(lista): creazione nuova istanza" );
            cmd300Class cmd = new cmd300Class( addC, portC );
            cmd.set( gs );
            cmd.start(); 
         }
      } catch ( Exception e ) {
         if (DbFS.intClient) 
            DbFS.outMexLn(getName()+"(lista): Eccezione "+e.toString());
      }
   }//cmd300
   
   void cmd000( DatagramPacket pck ) {
      try {
         if (DbFS.intClient) DbFS.outMexLn(getName()+": gestione comando inesistente");
         InetAddress addC = pck.getAddress();   //IP client
         int portC = pck.getPort();             //porta client
         DatagramPacket pckInvio = new DatagramPacket( Comando.CmdInesistente.getBytes(), 
            Comando.CmdInesistente.length(), addC, portC ); 
         sock.send( pckInvio );
      }
      catch (Exception e) {
         if (DbFS.intClient) 
            DbFS.outMexLn(getName()+"(inesistente): Eccezione "+e.toString());
      }
   }//cmd000
   
}//intClient

