//-----------------------------------------------------------------------------
// intDat.java
// package: FileServer
// 
// interprete dei comandi 
//
// data: 18-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;

public abstract class intDat extends Thread {

   public Vector com;   // colonna dei comandi
   public Vector met;   // colonna dei metodi
   protected byte dati[];
   public DatagramSocket sock;
   protected gestore gs;  // gestore associato
   public static int lungDati = 255;
   
   public intDat( gestore gs ) {
      super();
      this.gs = gs;
   }//intDat
   
   public void run() {
      while( true ) {
         try {
            //creazione di un nuovo datagramma
            DatagramPacket pck = new DatagramPacket( dati, lungDati );
            //ricezione datagramma
            sock.receive( pck );
            //creazione gestore richiesta
            new creaCmd( pck, this );
         } catch (Exception e) {
            if (DbFS.intDat) DbFS.outMexLn( getName()+": Eccezione " + e.toString() );
         }
      }
   }//run

}//intDat

class creaCmd extends Thread {
   
   protected DatagramPacket pck;
   protected intDat iD;
   
   public creaCmd( DatagramPacket pck, intDat iD ) {
      super();
      this.pck = pck;
      this.iD = iD;
      start();
   }//creaCmd
   
   public void run() {
      try {
         String cmd = new String( pck.getData(), 0, pck.getLength() );
         if (DbFS.creaCmd) DbFS.outMexLn(getName() + ": letto >" + cmd + "<" );
         StringReader str = new StringReader( cmd );
         StreamTokenizer st = new StreamTokenizer( str );
         st.parseNumbers();
         st.wordChars( (int)'/', (int)'/' );
         st.nextToken();
         int valCmd = 0;
         if ( st.ttype != StreamTokenizer.TT_NUMBER ) 
            //comando inesistente
            valCmd = 0;
         else valCmd = (int) st.nval;
         //lettura del codice che identifica il comando
         int ind;
         ind = iD.com.indexOf( new Integer( (int) valCmd ) );
         if ( ind == -1 || valCmd == 0 ) {
            //comando inesistente
            ind = iD.com.indexOf( new Integer( 0 ) );
            if (DbFS.creaCmd) DbFS.outMexLn(getName()+": comando inesistente");
            Object arg[] = new Object[1];
            arg[0] = pck;
            ( ( Method ) iD.met.elementAt( ind ) ).invoke( iD, arg ); 
         }
         else {
            //comando esistente
            if (DbFS.creaCmd) DbFS.outMexLn(getName()+": riconosciuto " + 
               String.valueOf( (int) st.nval ) );
            //preparazione dei parametri da passare
            Object arg[] = new Object[2];
            arg[0] = st;
            arg[1] = pck; 
            ( ( Method ) iD.met.elementAt( ind ) ).invoke( iD, arg ); 
         }
      } catch ( Exception e ) {
         if (DbFS.creaCmd) DbFS.outMexLn(getName()+": Eccezione "+e.toString() );
      }
   }//run
   
}//creaCmd