//-----------------------------------------------------------------------------
// intServer.java
// package: FileServer
// 
// interprete dei comandi sulla rete dei server
//
// data: 18-01-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;

public class intServer {

   protected gestore    gs;   //gestore della rete
   protected nameServer ns;   //nameServer
   protected trasm      tr;   //trasmettore comandi
   Vector     ricez; //tabella degli stream di ricezione
   protected Vector     thrRic; //tabella dei thread per la gestione degli stream
   protected static ThreadGroup ricGroup = new ThreadGroup("ricComandi");
   
   public intServer( gestore gs, nameServer ns, trasm tr, int dim, int inc  ) {
      this.gs = gs;
      this.ns = ns;
      this.tr = tr;
      ricez = new Vector( dim, inc );
      thrRic = new Vector( dim, inc );
   }//intServer
   
   public synchronized void ins( ObjectInputStream in ) {
      if (DbFS.intServer) 
         DbFS.outMexLn("intServer: (ins) richiesta di inserimento nuova entry");
      if (DbFS.intServer) 
         DbFS.outMexLn("intServer: (ins) numero attuale elementi " + 
         String.valueOf( ricez.size() ));
      //creazione ed inserimento in tabella del nuovo thread di gestione
      thrRic.addElement( new thrIn( in, ns, tr, gs ) );
      //inserimento ObjectInputStream in tabella
      ricez.addElement( in );
      if (DbFS.intServer) 
         DbFS.outMexLn("intServer: (ins) inserita nuova entry nella tabella");
      if (DbFS.intServer) 
            DbFS.outMexLn("intServer: (ins) numero attuale elementi " + 
            String.valueOf( ricez.size() ));
   }//ins

   public synchronized void canc( int indice ) {
      if (DbFS.intServer) DbFS.outMexLn("intServer: (canc) ingresso"); 
      try {
         ( (ObjectInputStream) ricez.elementAt( indice ) ).close();
         if (DbFS.intServer) DbFS.outMexLn("intServer: (canc) chiuso ObjectInputStream");  
      } catch (Exception e) {
         if (DbFS.intServer) DbFS.outMexLn("intServer: (canc) Eccezione: "+e.toString() );
      }
      ricez.removeElementAt( indice );
      thrRic.removeElementAt( indice );
      if (DbFS.intServer) DbFS.outMexLn("intServer: (canc) ucciso thread di gestione");   
      if (DbFS.intServer) 
         DbFS.outMexLn("intServer: (canc) Cancellata entry nella tabella (size="
         + String.valueOf( ricez.size() ) );
   }//canc
   
   public synchronized String toString() {
      String out = new String("( ");
      int ind = 0;
      while ( ind < ricez.size() ) {
         out = out.concat( "( " + String.valueOf( ind ) +" . ( "+ 
             ( ( ObjectInputStream) ricez.elementAt( ind ) ).toString() + " . " + 
             ( ( thrIn ) thrRic.elementAt( ind ) ).toString() + ") ) ");
         ind++;
      }
      out = out.concat( new String(")") );
      return out;
   }//toString

   public static void main( String args[] ) {
   }//main

}//intServer

class thrIn extends Thread {

   protected ObjectInputStream in;
   protected nameServer ns;
   protected trasm tr;
   protected gestore gs;

   public thrIn( ObjectInputStream in, nameServer ns, trasm tr, gestore gs ) {
   //thread per la gestione della ricezione di comandi da un ObjectInputStream
      super( intServer.ricGroup, "ric" );
      this.in = in;
      this.ns = ns;
      this.tr = tr;
      this.gs = gs;
      start();
   }//thrIn 

   public void run() {
      Comando cmd;
      try {
         while( true ) {
            cmd = (Comando) in.readObject();
            if (DbFS.thrIn) 
               DbFS.outMexLn(getName()+": ricevuto comando "+ cmd.toString() );
            //esecuzione del comando
            cmd.set( gs );
            cmd.start();
         }
      } catch ( Exception e ) {
         if (DbFS.thrIn) DbFS.outMexLn(getName()+": Eccezione "+e.toString());
         if (e.getClass().isInstance( new EOFException() ) ||
             e.getClass().isInstance( new SocketException() ) ) {
            if ( DbFS.thrIn ) 
               DbFS.outMexLn(getName()+": crash socket ingresso" );
            gs.notifyCrashIn( gs.is.ricez.indexOf( in ) );
         }
      }
   }//run
  
}//thrIn