//-----------------------------------------------------------------------------
// newPred.java
// package: FileServer
// 
// comando con cui si aggiorna un nodo predecessore a seguito di un inserimento
//
// data: 29-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class newPred extends Comando{
   
   gestReteAnello gR;
   InetAddress newServer;
   int inPortNewServ;

   public newPred( InetAddress newServer, int inPortNewServ ){
      super( "newPred" );
      this.newServer = newServer;
      this. inPortNewServ = inPortNewServ;
   }//newPred
   
   public void set( gestore gR ){
      this.gR = ( gestReteAnello ) gR;
   }//set
   
   public void run() {
      //aggiornamento nodo
      if (DbFS.cmdRete) DbFS.outMexLn(getName()+": aggiornamento nodo");
      if (gR.disp) {
         //successore presente
         //aggiornamento nodo
         gR.succ2Add = newServer;
         gR.succ2Port = inPortNewServ;
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+"\nsucc2="+gR.succ2Add+
            "\nsucc="+gR.succAdd+"\npred="+gR.pred);
         if (DbFS.cmdRete) DbFS.outMexLn("(newPred): salvataggio configurazione ("+
            gR.fileConfig+")" );
         try {
            gR.saveConnOut( gR.fileConfig );
         } catch (Exception e) {
            if (DbFS.cmdRete) 
               DbFS.outMexLn("(newPred)Eccezione salvataggio nuova configurazione "+e);
         }
      }
      else {
         //successore caduto
         //inserimento comando di aggiornamento in coda comandi persi
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+": successore caduto\n"+
            "Inserimento aggPred in coda comandi persi successore\n" +
            "coda="+gR.coda);
         if ( gR.coda.size() == 0 ) {
            gR.coda.addElement( new aggPred( newServer, inPortNewServ ) );
            if (DbFS.cmdRete) DbFS.outMexLn(getName()+": inserito comando in "+
               "coda comandi vuota" );
         }
         else {
            int i = 0;
            Comando cmd = (Comando) gR.coda.elementAt(i);
            while( i < gR.coda.size() && 
                   ( cmd instanceof aggPred || cmd instanceof aggSucc) ) {
               i++;
               cmd = (Comando) gR.coda.elementAt(i);
            }
            if ( i < gR.coda.size() )
               gR.coda.insertElementAt( 
                  new aggPred( newServer, inPortNewServ ), i);
            else
               gR.coda.addElement( new aggPred( newServer, inPortNewServ ) );
         }
      }
      //invia ack
      try {
         ObjectOutputStream outObj = new ObjectOutputStream( gR.sockCom.getOutputStream() );
         outObj.writeObject( new String("") );
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+": spedito ack");
         closeSock();
      }
      catch( Exception e) {
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+": Eccezione "+e.toString() );
      }
   }//run

   void closeSock() {
      try {
         gR.sockCom.close();
      } catch( Exception e ) {
         closeSock();
      }
   }//closeSock

}//newPred