//-----------------------------------------------------------------------------
// newServer.java
// package: FileServer
// 
// applicazione per la creazione di un server che vuole collegarsi alla rete
//
// data: 29-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.util.*;

public class newServer {

   boolean start = false;
   
   public newServer() { };
   
   public static void main( String args[] ) {
   //args[0]: nome name server da creare
   //args[1]: porta di ingresso rete server (inPort)
   //args[2]: porta di uscita rete server (outPort)
   //args[3]: porta interprete server di ingresso/ricezione comandi 
   //args[4]: porta client
   //args[5]: IP server cui inoltrare la richiesta di inserimento
   //args[6]: porta server sul server su cui inoltrare la richiesta
   //creazione name server vuoto
      int inPort = ( new Integer( args[1] ) ).intValue();
      int outPort = ( new Integer( args[2] ) ).intValue();
      int portServer = ( new Integer( args[3] ) ).intValue();
      int portServRich = ( new Integer( args[6] ) ).intValue();
      int portClient = ( new Integer( args[4] ) ).intValue();
      try {
         if (DbFS.SHOW) DbFS.OpenDbgWin( args[0] );
         nameServer.newNSvuoto( args[0] );
         gestReteAnello gs = new gestReteAnello( args[0], inPort, outPort, portClient, 
            portServer, true ); 
         new servConsRete( gs, ( "(inPort="+args[1]+";outPort="+args[2]+")" ) );
         new servCons( gs, ( "(inPort="+args[1]+";outPort="+args[2]+")" ) );
         if (DbFS.SHOW) DbFS.setGestore( gs );
         newServer nS = new newServer();
         //creazione thread di ascolto su porta server
         new waitRes( portServer, gs, nS );
         if (DbFS.SHOW) DbFS.CloseDbgWin();
         //creazione datagramma richiesta
         byte rich[] = new byte[ 30 ];
         rich = ( new String("500") ).getBytes();
         DatagramPacket pck = new DatagramPacket( rich, rich.length, 
               InetAddress.getByName( args[5] ), portServRich );
         System.out.println("Preparato datagramma richiesta");
         //creazione socket di invio richiesta
         while ( !nS.start ) {
            //invio richiesta
            gs.iNs.sock.send( pck );
            System.out.println("Inviato datagramma richiesta");
            synchronized( gs.iNs.sock ) {
               try {
                  gs.iNs.sock.wait( 10000 );
               } catch( Exception e ) { }
            }
            System.out.println("Scaduto time-out");
         }
      if (DbFS.SHOW) DbFS.outMexLn("Parametri:\nsuccAdd: "+gs.succAdd+"; succPort:"+
         String.valueOf(gs.succPort)+"\nsucc2Add: "+gs.succ2Add+"; succ2Port: "+
         String.valueOf(gs.succ2Port)+"\npred: "+gs.pred+"\ncoda: "+gs.coda);
      } catch (Exception e) {
         System.out.println("newServer: Eccezione "+e.toString() );
      }
   }//main
   
}//newServer

class waitRes extends Thread {
   
   int port;
   newServer nS;
   gestReteAnello gs;
   
   public waitRes( int port, gestReteAnello gs, newServer nS ) {
      super();
      this.port = port;
      this.nS = nS;
      this.gs = gs;
      start();
   }//waitRes
   
   public void run() {
      try {
         //attesa risposta su porta server
         ServerSocket ser = new ServerSocket( port );
         System.out.println("In attesa di risposta su porta tcp");
         Socket s = ser.accept();
         nS.start = true;
         System.out.println("Accettata connessione con risposta");
         s.setSoLinger(true, 100);
         gs.operNewServ( ser, s );
         System.out.println("Server inserito nell'anello");
      } catch( Exception e ) {
         System.out.println("Server: Eccezione "+e );
      }
   }//run

}//waitRes