//-----------------------------------------------------------------------------
// newSucc.java
// package: FileServer
// 
// comando con cui si aggiorna un nodo successore a seguito di un inserimento
//
// data: 29-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class newSucc extends Comando{
   
   gestReteAnello gR;
   InetAddress newServer;
   int portNewServ;

   public newSucc( InetAddress newServer, int portNewServ ) {
      super( "newSucc" );
      this.newServer = newServer;
      this.portNewServ = portNewServ;   
   }//newSucc

   public void set( gestore gR ){
      this.gR = ( gestReteAnello ) gR;
   }//set
   
   public void run() {
      //aggiornamento nodo
      if (DbFS.cmdRete) DbFS.outMexLn(getName()+": aggiornamento successore" );
      gR.pred = newServer;
      gR.portServPred = portNewServ;
      if (DbFS.cmdRete) DbFS.outMexLn("(newSucc): salvataggio configurazione ("+
         gR.fileConfig+")" );
      try {
         gR.saveConnOut( gR.fileConfig );
      } catch (Exception e) {
         if (DbFS.cmdRete) 
            DbFS.outMexLn("(newSucc)Eccezione salvataggio nuova configurazione "+e);
      }
      //invio ack al cliente
      try {
         ObjectOutputStream out = new ObjectOutputStream( gR.sockCom.getOutputStream() );
         out.writeObject( new String("") );
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+": spedito ack");
         closeSock();
      } catch (Exception e) {
         if (DbFS.cmdRete) DbFS.outMexLn(getName()+": Eccezione "+e.toString() );
      }   
   }//run
   
   void closeSock() {
      try {
         gR.sockCom.close();
      } catch( Exception e ) {
         closeSock();
      }
   }//closeSock

}//newSucc