//-----------------------------------------------------------------------------
// servNSPanel.java
// package: FileServer
// 
// console per l'inserimento di comandi per di inserimento e cancellazione
// file dal name server
//
// data: 24-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class servNSPanel extends Panel{

   TextField pathLine; //inserimento nome logico  
   TextField fisLine;  //inserimento nome fisico 
   TextField mexLine;  //linea dei messaggi
   TextArea  area;     //area di visualizzazione 

   gestAnelloNS gs;
   public static String insert = "Inserisci";
   public static String cancel = "Cancella";
   public static String listaString = "Lista";
   public static String propString = "Proposte";
   public static String salvaString = "Salva NS";
   public static String clearScreen = "Clear";
   
   public static int dimX = 500;
   public static int dimY = 400;

   public servNSPanel( gestAnelloNS gs ) {
      this.gs = gs;   //gestore su cui agire
      initWin();
   }//servNSPanel
   
   private servNSPanel( ) {
      this( null );
   }//servNSPanel

   protected void initWin() {
      //definizione della finestra
      //pulsanti comandi
  	   Button ins = new Button( insert );
 	   ins.addActionListener( new buttonAct( this, ins ) );
 	   Button canc = new Button( cancel );
 	   canc.addActionListener( new buttonAct( this, canc ) );
	   Button salva = new Button( salvaString );
	   salva.addActionListener( new ctrAct( this, salva ) ); 
  	   //pulsantiera per comandi
      Panel puls = new Panel();
      puls.setLayout( new GridLayout( 1, 5 ) );
      Label com = new Label("Comandi:");
      com.setAlignment( Label.CENTER );
      puls.add( com );
      puls.add( ins );
      puls.add( canc );
      puls.add( new Panel() );
      puls.add( salva );
      //campi di ingresso
      //riga1: inserimento path logico
      Panel riga1 = new Panel();
      riga1.setLayout( new FlowLayout() );
      riga1.add( new Label("Nome Logico: ") );
      pathLine = new TextField( 50 );
      riga1.add( pathLine );
      //riga2: inserimento nome fisico
      Panel riga2 = new Panel();
      riga2.setLayout( new FlowLayout() );
      riga2.add( new Label("Nome Fisico: ") );
      fisLine = new TextField( 50 );
      riga2.add( fisLine );
      //area di output
      area = new TextArea("Area di output\n");
      area.setEditable( false );
      //pulsanti controllo
      Button lista = new Button( listaString );
      lista.addActionListener( new ctrAct( this, lista ) );
      Button prop = new Button( propString );
      prop.addActionListener( new ctrAct( this, prop ) );
      Button clear = new Button( clearScreen );
      clear.addActionListener( new ctrClear( area ) );
      //pulsantiera per controllo
      Panel pulsCtr = new Panel();
      pulsCtr.setLayout( new GridLayout( 1, 5 ) );
      pulsCtr.add( lista );
      pulsCtr.add( prop );
      pulsCtr.add( clear );
      //pannello centrale
      Panel centrale = new Panel();
      centrale.add( riga1 );
      centrale.add( riga2 );
      centrale.add( pulsCtr );
      centrale.add( area );
      //area messaggi
      mexLine = new TextField("Area messaggi di controllo", 50);
      mexLine.setBackground(Color.white);
      mexLine.setEditable( false );
      
      //impostazioni finestra di Debug	
      setLayout( new BorderLayout() );
      add( puls, BorderLayout.NORTH );	
      add( centrale, BorderLayout.CENTER );
      add( mexLine, BorderLayout.SOUTH );
      setSize( dimX, dimY ); 
      setVisible(true);

   }//initWin
   
   public static void main( String args[] ) {
      Frame f = new Frame("prova");
      f.add( new servNSPanel( ) );
      f.setSize( dimX, dimY );
      f.setVisible(true);
   }//main

}//servNSPanel

class buttonAct implements ActionListener {
	
	servNSPanel dg;   //finestra da controllare 
	Button bg;     //bottone premuto
	
	public buttonAct ( servNSPanel dg, Button bg ) {
		this.dg = dg;
		this.bg = bg;
	}//buttonAct
	
	public void actionPerformed( ActionEvent e ) {
	   try {
	      String stream = dg.pathLine.getText();
	      StringReader s = new StringReader( stream );
         StreamTokenizer st = new StreamTokenizer( s );
         st.wordChars( (int)'.', (int)'.' );
         st.wordChars( (int)':', (int)':' );
         st.wordChars( (int)'/', (int)'/' );
         st.wordChars( (int)'0', (int)'9' );
         //lettura primo token
         st.nextToken();
         if (st.ttype!=StreamTokenizer.TT_WORD) 
            dg.mexLine.setText("path logico non corretto");
         else {
            pathName path = new pathName( st.sval );
            System.out.println("Logico: letto "+st.sval );
            st.nextToken();
            if (st.ttype!=StreamTokenizer.TT_EOF)
               dg.mexLine.setText("path logico non corretto"); 
            else { //path logico corretto
               if ( bg.getLabel().equals( servNSPanel.insert ) ) {
         	      stream = dg.fisLine.getText();
         	      s = new StringReader( stream );
                  st = new StreamTokenizer( s );
                  st.wordChars( (int)'.', (int)'.' );
                  st.wordChars( (int)'/', (int)'/' );
                  st.wordChars( (int)'0', (int)'9' );
                  st.wordChars( (int)':', (int)':' );
                  st.nextToken();
                  if ( st.ttype != StreamTokenizer.TT_WORD ) 
                     dg.mexLine.setText("nome fisico non corretto");
                  else  { //path logico e nome fisico corretti
                     String fis = st.sval;
                     System.out.println("Fisico: letto "+st.sval);
                     st.nextToken();
                     if ( st.ttype != StreamTokenizer.TT_EOF ) 
                        dg.mexLine.setText("nome fisico non corretto");
                     else {
                        File nf = new File( fis );
                        if ( nf.exists() ) {
                           //inserimento
                           insLoc ins = new insLoc( true, InetAddress.getLocalHost(),  
                              dg.gs.inPort, new ric( path, fis, true ) );
                           ins.set( dg.gs );
                           ins.start();
                           dg.mexLine.setText("Creato nuovo comando di inserimento");
                         }
                         else //nome fisico non esiste
                           dg.mexLine.setText("Nome fisico non esistente");
                     }
                  }
               }
               else {
                  //cancellazione
                  cancLoc canc = new cancLoc( true, InetAddress.getLocalHost(),
                     dg.gs.inPort, new ric( path, nameServer.fisicoEsterno, false ) );
                  canc.set( dg.gs );
                  canc.start();
                  dg.mexLine.setText("Creato nuovo comando di cancellazione");
               }
            }
         }
         dg.fisLine.setText("");
         dg.pathLine.setText("");
		} catch ( Exception exc ) {
		   dg.mexLine.setText( "(buttonAct): " + exc.toString() );
		}
	}//actionPerfomed
		
}//buttonAct

class ctrAct implements ActionListener {
	
	servNSPanel dg;   //finestra da controllare 
	Button bg;     //bottone premuto
	
	public ctrAct( servNSPanel dg, Button bg ) {
		this.dg = dg;
		this.bg = bg;
	}//ctrAct
	
	public void actionPerformed( ActionEvent e ) {
	   try {
         if ( bg.getLabel().equals( servNSPanel.listaString ) )
            //premuto lista
            dg.area.append( "Name Server\n"+dg.gs.ns.lista() );
         else
            if ( bg.getLabel().equals( servNSPanel.salvaString ) ) {
               //premuto salva
               dg.gs.ns.salva();
               dg.mexLine.setText("Name Server: salvataggio eseguito");
            }
            else
               //premuto prop
               dg.area.append( "Proposte\n"+dg.gs.ns.listaProp() +"---\n" );
		} catch ( Exception exc ) {
		   dg.mexLine.setText( "(ctrAct): " + exc.toString() );
		}
	}//actionPerfomed
		
}//ctrAct

class ctrClear implements ActionListener {

	TextArea dg;	//area da controllare 
	
	public ctrClear ( TextArea dg ) {
		this.dg = dg;
	}//Clear
	
	public void actionPerformed( ActionEvent e ) {
		dg.setText("");
	}//actionPerfomed
	
}//ctrClear
