//-----------------------------------------------------------------------------
// trasm.java
// package: FileServer
// 
// gestore della tabella di trasmissione e della trasmissione dei 
// comandi sulla rete dei server
//
// data: 11-01-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.util.*;

public class trasm {

   //tabella dei buffer di invio
   protected Vector invio;    //array di buffer
   protected int dim;         //dimensione iniziale del buffer
	protected int inc;         //valore dell'incremento
	protected static ThreadGroup trGroup = new ThreadGroup("invioComandi");
	protected gestore gs;      //gestore della rete

   public trasm( gestore gs, int dim, int inc ) {
      this.gs = gs;
      this.dim = dim;
      this.inc = inc;
      invio = new Vector( dim, inc );
   }//trasm
   
   public void invia( Comando cmd ) {
      new sped( cmd, this );
   }//invia
   
   public synchronized void inviaInd( int ind, Comando cmd ) {
      if (DbFS.inviaInd) DbFS.outMexLn("trasm: (inviaInd) richiesta invio comando");
      try {
        ( (ObjectOutputStream) invio.elementAt( ind ) ).flush();
        ( (ObjectOutputStream) invio.elementAt( ind ) ).writeObject( cmd );
        ( (ObjectOutputStream) invio.elementAt( ind ) ).flush();
        if (DbFS.inviaInd) 
           DbFS.outMexLn("trasm: (inviaInd) inviato con successo "+ cmd.toString() +
           "(ind="+String.valueOf( ind ) + ")");
      } catch ( Exception e ) {
         if (DbFS.inviaInd) DbFS.outMexLn("trasm: (inviaInd) Eccezione "+e.toString());
            if ( DbFS.inviaInd ) 
               DbFS.outMexLn("trasm: (inviaInd) crash socket (ind="+ind+")" );
            gs.notifyCrashOut( ind, cmd );
      }
   }//inviaInd
   
   public synchronized int ins( ObjectOutputStream out ) {
      if (DbFS.ins) DbFS.outMexLn("trasm: (ins) richiesta di inserimento nuova entry");
      if (DbFS.ins) 
         DbFS.outMexLn("trasm: (ins) numero attuale elementi " + 
         String.valueOf( invio.size() ));
      int ind = invio.size(); //posizione in cui verr inserito l'elemento
      invio.addElement( out );
      if (DbFS.ins) DbFS.outMexLn("trasm: (ins) numero attuale elementi " + 
         String.valueOf( invio.size() ));
      return ind;
   }//ins
   
   public  synchronized void canc( int indice ) {
      try {
         ( ( ObjectOutputStream ) invio.elementAt( indice ) ).close();
      } catch (Exception e) { }
      invio.removeElementAt( indice );
      if (DbFS.canc) DbFS.outMexLn("trasm: (canc) Cancellata entry nella tabella");
   }//canc
   
   public String toString() {
      String out = new String("( ");
      int ind = 0;
      while ( ind < invio.size() ) {
         out = out.concat( "( " + String.valueOf( ind ) +" . "+ 
            ( ( ObjectOutputStream) invio.elementAt( ind ) ).toString() + " ) ");
         ind++;
      }
      out = out.concat( new String(")") );
      return out;
   }//toString
   
   public static void main( String args[] ) {/*
   }//main
   
   
}//trasm


class sped extends Thread {

   Comando cmd;
   trasm   tr;
   
   public sped( Comando cmd, trasm tr ) {
      super( trasm.trGroup, "sped" );
      this.cmd = cmd;
      this.tr = tr;
      start();
   }//sped

   public void run() {
      int ind = 0;
      while( ind < tr.invio.size() ) {
         tr.inviaInd( ind, cmd );
         ind++;
      }
   }//run

}//sped