//-----------------------------------------------------------------------------
// winIOobj.java
// package: io
// 
// finestra per fornire stream di ingresso ad oggetti
// (vedi in fondo per codice da inserire nel codice dell'altra classe)
//
// data: 05-02-2000
//-----------------------------------------------------------------------------

package io;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class winIOobj extends Frame {

   public    TextArea area;     //buffer di ingresso 
   public    PipedInputStream  pRead;
   public    PipedOutputStream out;   //buffer su cui scrivere
   public    ObjectOutputStream outObj;
   public    TextArea  mexLine;
	
	public winIOobj( PipedInputStream pRead )	{
	   super("Finestra di input");
      this.pRead = pRead;	
		this.addWindowListener	(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dispose();
				System.exit(0);
			}
		});
		initWin();
   }//winIOobj
   
	public winIOobj( PipedInputStream pRead, String name )	{
	   super("Finestra di input: " + name );
	   this.pRead = pRead;
		this.addWindowListener	(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dispose();
				System.exit(0);
			}
		});
		initWin();
   }//winIOobj
   
		
	protected void initWin() {
		try {
   		out = new PipedOutputStream( pRead );
   	   outObj = new ObjectOutputStream( out );
   	   //pulsanti
   	   Button invio = new Button( "Invio" );
   	   invio.addActionListener( new invioStream( this ) );
   	   Button clear = new Button( "Clear" );
   	   clear.addActionListener( new Clear( this ) );
   	   Button close = new Button( "Close" );
   	   close.addActionListener( new Close( this ) );
   
   	   //pulsantiera per opzioni
   		Panel puls = new Panel();
   		puls.setLayout( new GridLayout( 1, 5 ) );
   		puls.add( invio );
   		puls.add( new Panel() );
   		puls.add( new Panel() );
   		puls.add( close );
   		puls.add( clear );
   		//area di testo
   		area = new TextArea( "", 5, 50, TextArea.SCROLLBARS_VERTICAL_ONLY ); 
   		area.setBackground(Color.white);
   		area.setEditable( true );
   		//area messaggi
   		mexLine = new TextArea("Area messaggi\n", 10, 50, TextArea.SCROLLBARS_VERTICAL_ONLY );
   		mexLine.setBackground(Color.white);
   		mexLine.setEditable( false );
   		
   		//impostazioni finestra di Debug	
   		setLayout( new BorderLayout() );
   		add( puls , BorderLayout.NORTH );	
   		add( area, BorderLayout.CENTER );
   		add( mexLine, BorderLayout.SOUTH );
   		setSize(400,400); 
   		setVisible(true);
      } catch ( Exception e ) {
         System.out.println("(winIOobj) Eccezione: " + e.toString()+"\n" );
      }
	}//initWin
	
	public static void main( String args[] ) {
	   try {
   	   PipedInputStream pipeR = new PipedInputStream( );
   	   winIOobj win = new winIOobj( pipeR );
/*	      ObjectInputStream inObj = new ObjectInputStream( pipeR );
   	   while ( true ) {
	         String l = (String) inObj.readObject() ;
	         System.out.println ( "Letto: " + l );
	         if ( l.equals("CHIUSO") ) {
	            System.out.println("Arrivato comando di chiusura estremo di in");
	            inObj.close();
	         }
   	   } */
	   } catch ( Exception e ) { 
	      System.out.println("(main) Eccezione: " + e.toString()+"\n" );
	   }
	}//main
	
}//winIOobj

class invioStream implements ActionListener {
	
	winIOobj dg;   //finestra da controllare 
	
	public invioStream ( winIOobj dg ) {
		this.dg = dg;
	}//Clear
	
	public void actionPerformed( ActionEvent e ) {
	   try {
	      String stream = dg.area.getText();
         dg.outObj.writeObject( stream );
         dg.area.setText("");
         dg.mexLine.setText("inviato >>" + stream + "<<\n");
		} catch ( Exception exc ) {
		   dg.mexLine.setText( "(invioStream): " + exc.toString()+"\n" );
		}
	}//actionPerfomed
		
}//invioStream

class Clear implements ActionListener {

	winIOobj dg;	//finestra da controllare 
	
	public Clear ( winIOobj dg ) {
		this.dg = dg;
	}//Clear
	
	public void actionPerformed( ActionEvent e ) {
		dg.area.setText("");
		dg.mexLine.setText("Cancellata l'area messaggi\n");	
	}//actionPerfomed
	
}//Clear

class Close implements ActionListener {

	winIOobj dg;	//finestra da controllare 
	
	public Close ( winIOobj dg ) {
		this.dg = dg;
	}//Clear
	
	public void actionPerformed( ActionEvent e ) {
	   try {
		   dg.out.close();
		} catch ( IOException exc ) {
		   dg.mexLine.setText("IOException durante la chiusura flusso\n");
		}
		dg.mexLine.setText("Chiuso flusso\n");	
	}//actionPerfomed
	
}//Close

